"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.build = void 0;
const child_process_1 = require("child_process");
const fs = __importStar(require("fs"));
const path = __importStar(require("path"));
const _1 = require(".");
let _builtWorkspaces = false, _builtBinaries = false;
/**
 * Build with Cross
 */
function build(options) {
    try {
        let outputName;
        let shouldCompile;
        let extra_args;
        // Build binary
        if (options.bin) {
            outputName = options.bin;
            if (_builtBinaries) {
                shouldCompile = false;
                extra_args = undefined;
            }
            else if (_1.Settings.BUILD_INDIVIDUALLY) {
                shouldCompile = true;
                extra_args = ['--bin', outputName];
            }
            else {
                _builtBinaries = true;
                shouldCompile = true;
                extra_args = ['--bins'];
            }
        }
        // Build package - i.e. workspace member
        else {
            outputName = options.package;
            if (_builtWorkspaces) {
                shouldCompile = false;
                extra_args = undefined;
            }
            else if (_1.Settings.BUILD_INDIVIDUALLY) {
                shouldCompile = true;
                extra_args = ['--package', outputName];
            }
            else {
                _builtWorkspaces = true;
                shouldCompile = true;
                extra_args = ['--workspace'];
            }
        }
        if (shouldCompile) {
            console.log(`🍺  Building Rust code with \`cross\`. This may take a few minutes...`);
            const args = [
                'build',
                '--release',
                '--target',
                options.target,
                ...extra_args,
            ];
            const cross = (0, child_process_1.spawnSync)('cross', args, {
                cwd: options.entry,
            });
            if (cross.error) {
                throw cross.error;
            }
            if (cross.status !== 0) {
                throw new Error(cross.stderr.toString().trim());
            }
        }
        let from = path.join(options.entry, 'target', options.target, 'release', outputName);
        let to = path.join(options.outDir, 'bootstrap');
        fs.copyFileSync(from, to);
    }
    catch (err) {
        throw new Error(`Failed to build file at ${options.entry}: ${err}`);
    }
}
exports.build = build;
